/**
 * Examples of Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

var tas = require('../../tas');
var a;

var tasks = function(){

	a = 1;

	tas(function(){
		a ++; // 2
		setTimeout(tas.next, 0);
	});

	// The tasks in tas.all() will be performed concurrently,
	// the whole task time is the longest task time.
	tas.all({
		t1: function(){
			a ++; // 3
			setTimeout(this.done, 10);
		},

		t2: function(){
			a ++; // 4
			setTimeout(this.done, 30);
		},

		t3: function(){
			a ++; // 5
			setTimeout(this.done, 20);
		},
	});

	tas(function(err, data){
		if (err) return tas.abort();
		console.log(data.length);
		console.log(a); // 5
		tas.next();
	});
};

var exports = {
	do: function(){
		tas(tasks);
	}
};

module.exports = exports;
