/**
 * Test of Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

var tester = require('../tester');
var expect = require('chai').expect;

describe('2.breaking-flow: abort in tas.all()', function(){
	it('should return ,5', function(done){

		var test = function(done, count){

			var tas = require('../tas').begin();
			var a = 1;

			tas(function(){
				a ++; // 2
				setTimeout(tas.next, 0);
			});

			// The tasks in tas.all() will be performed concurrently,
			// the whole task time is the longest task time.
			tas.all({
				t1: function(){
					a ++; // 3
					setTimeout(this.done, 10);
				},

				t2: function(){
					a ++; // 4
					setTimeout(this.done, 30);
				},

				t3: function(){
					a ++; // 5
					setTimeout(this.done, 20);
				},
			});

			tas(function (err, data){ // ignored when count === 1
				done(count, a);
				tas.end();
			});
		};

		var check = function(results){
			expect(results.toString() === ',5').to.be.equal(true);
			done();
		};

		// Run the test twice
		tester.do(test, check, 2);
	});
});
