/**
 * Test of Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

var tester = require('../tester');
var expect = require('chai').expect;

describe('4.usage: performing multiple tasks concurrently', function(){
	it('should return ,5', function(done){

		var test = function(done, count){

			var tas = require('../tas').begin();
			var app = require('./performing-multiple-tasks-concurrently/app').do(count);

			tas(function (){ // ignored when count === 1
				done(count, app.get());
				tas.end();
			});
		};

		var check = function(results){
			expect(results.toString() === ',5').to.be.equal(true);
			done();
		};

		// Run the test twice
		tester.do(test, check, 2);
	});
});
